image: node:latest

before_script:
  - echo "unsafe-perm=true" | tee --append .npmrc
  - npm ci --cache .npm --prefer-offline

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .npm/

workflow:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: always
    - if: '$CI_COMMIT_BRANCH == "alpha"'
      when: always
    - when: never

stages:
  - prepare
  - deploy

lint:
  stage: prepare
  script:
    # - npm run lint
    - echo "prettier and eslint together do weird things"

test-node-15:
  stage: prepare
  script:
    - npm run test:coverage
  coverage: /All\sfiles.*?\s+(\d+.\d+)/
  artifacts:
    when: always
    reports:
      junit:
        - coverage/clover.xml

test-node-lts-14:
  image: node:lts
  stage: prepare
  script:
    - npm run test

test-node-12:
  image: node:12
  stage: prepare
  script:
    - npm run test

build:
  stage: prepare
  script:
    - npm run build

deploy:
  stage: deploy
  rules:
    - if: '$CI_COMMIT_BRANCH == "alpha"'
      when: on_success
    - when: never
  script:
    - npm config set '//registry.npmjs.org/:_authToken' "${NPM_TOKEN}"
    - npm run semantic-release
